#!/usr/local/bin/perl

############################
######  Chat V 2.0 #############
###### all rights reserved  #######
##  SEE THE COPYRIGHT-FILE !!##
## by Daniel and Christian Haese ##
############################

# Maybe the first line has to be changed (it points to perl on your server) (maybe #!/usr/bin/perl)
###################################################################

# Set the Variables :

$chatreal = "/u/fjur/dhaese/WWW/chat/chat.html"; ### You have to change this line !!!! ###
$chaturl = "http://www.rzuser.uni-heidelberg.de/bin/user/~dhaese/chat.pl"; ### You have to change this line !!!! ###
$date_command = "/usr/bin/date"; # Maybe you have to change this line, too #

#### all following lines do not need to be changed !!!!! #########################

$message_number = 0;

### Set the Options: ###################################################

$max_messages = 150; ## number of messages that can be stored - the oldest submitted messages drop out
$allow_html = 0;   ## 1 = Yes; 0 = No
$line_breaks = 1;	## 1 = Yes; 0 = No

###################################################################

# Get the Date
$date = `$date_command +"%A, %B %d, %Y at %T (%Z)"`; chop($date);

###################################################################

# Get the input #######################################

$buffer=$ENV{'QUERY_STRING'};
# Split the name-value pairs
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
   ($name, $value) = split(/=/, $pair);
   # Un-Webify plus signs and %-encoding
   $value =~ tr/+/ /;
   $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
   $value =~ s/<!--(.|\n)*-->//g;
   if ($allow_html != 1) {
      $value =~ tr/</ /;
      $value =~ tr/>/ /;
   }
   $FORM{$name} = $value;
}

##################################################################

if ($FORM{'numofmes'} == 0) {
   $FORM{'numofmes'} = 20;
}
&check_messages unless $FORM{'comments'}; # reload the page and check for new messages if no message was submitted

##################################################################

############## Add the submitted message to the chat page (html)
# the whole page is rewritten and the new message is added

open (CHAT,"$chatreal") || die "Can't Open $chatreal: $!\n";
@LINES=<CHAT>;
close(CHAT);
$SIZE=@LINES;

open (CHAT,">$chatreal") || die "Can't Open $chatreal: $!\n";

for ($i=0;$i<=$SIZE;$i++) {
   $_=$LINES[$i];
   if (/<!--beginofmessages-->/) { 
      print CHAT "<!--beginofmessages-->\n"; 
      if ($line_breaks == 1) {
         $FORM{'comments'} =~ s/\cM\n/<br>\n/g;
      }
      print CHAT "<b><em>$FORM{'realname'}: </em></b><br>\n";
      print CHAT "<b>$FORM{'comments'}</b><br>\n";
      print CHAT " - $ENV{'REMOTE_HOST'} - $date\n";
      print CHAT "<hr>\n"; 
      print CHAT "<!--message-->\n\n" ;
      $message_number++;
   }
   else {
      print CHAT $_;
      if(/<!--message-->/) {
         $message_number++;
         if($message_number eq $max_messages) {
            &delete; # if the number of messages is higher than max_messages the delete-function is launched
         }
      }
   }
}

close(CHAT);
&check_messages; #### print the new HTML - Page with the new messages
exit;

############### avoid that more than max_messages were stored at the HTML - Page --- the oldest message drops out!
# the message(s) following after the (max_messages). message are not rewritten to the file. If <!--endofmessages--> is reached,
# the function finishes.

sub delete {
  for ($ii=$i;$ii<=$SIZE;$ii++) {
     $_=$LINES[$ii];
     if (/<!--endofmessages-->/) {
        print CHAT "<!--endofmessages-->\n";
        $i=$ii;
        return;
     }
   }
}

############### print the Chat - Page (html) with the newest messages and the submitted name inside the namefield

sub check_messages {
   $message_number = 0;
   open (CHAT,"$chatreal") || die "Can't Open $chatreal: $!\n";
   @LINES=<CHAT>;
   close(CHAT);
   $SIZE=@LINES;
   print "Content-type: text/html\n\n";
   for ($j=0;$j<=$SIZE;$j++) {
     $_=$LINES[$j];

     # write the refresh - option in the head - line
     if(/<!--refresh-->/) {
        print "<!--refresh-->\n";
        $j++;
        $_=$LINES[$j];
        if(($FORM{'seconds'}) != "") {
          print "<meta HTTP-EQUIV=\"Refresh\" ";
          print "content=\"$FORM{'seconds'};url=$chaturl";
          print "?realname=$FORM{'realname'}&numofmes=$FORM{'numofmes'}&seconds=$FORM{'seconds'}&comments=";
          print "\" >\n";
        }
     }
     # write the submitted name in the namefield :
     if(/<!--namefield-->/)  {
       print "<!--namefield-->\n";
       print "Your Name:<input type=text name=\"realname\" size=30 ";
       print "value=\"$FORM{'realname'}\"><br>";
       print "number of displayed messages:<input type=text name=\"numofmes\" size=4 ";
       print "value=\"$FORM{'numofmes'}\"><br>\n";
       print "autoreload every <input type=text name=\"seconds\" size=3 ";
       print "value=\"$FORM{'seconds'}\"> seconds  <A HREF=\"#pause\">PAUSE</A><br>\n";

      $j++;
     }
     else {
       print "$_";

       if(/<!--message-->/) {
         $message_number++;
         if($message_number eq $FORM{'numofmes'}) {
            while (!(/<!--endofmessages-->/))
               {
               $j++;
               $_=$LINES[$j];
               }
            $j--;
         }
       }
     }
   }
exit;
}
